'###############################################################################
'# NAME      : echolink_enable_disable.vbs
'# AUTHOR    : Carl Gosselin - KG6WTF
'# VERSION   : 1.1.003
'# DATE      : FEB-22-2005
'#
'# PURPOSE   : - For repeaters, links or single-user
'#             - Automatically disable and enable Echolink twice a day.
'#             - FTP CallLog to website
'#             - Announce Station every hour
'#
'# Note      : You can use and/or modify this script as you want.
'#             
'# Email     : kg6wtf@gosselinfamily.com
'# Web       : http://kg6wtf.gosselinfamily.com
'#
'################################################################################
'#

  ' initiate EchoLink's Session component, and set up an event connection
  Set oEchoLink = WScript.CreateObject("EchoLink.EchoLinkSession", "EchoLink_")

  Dim ActiveConnections, bFirstConnect, sStationName, bSendlog

  ' prepare Popup Windows
  Set WshShell = WScript.CreateObject ("WScript.Shell")

  ' the Script can automatically disable and enable Echolink twice a day.
  ' You can't overlay on two days. It's from 00h00 to 23:59
  AutoLinkDisable = True
  LinkOnTime1 = "00:05"
  LinkOffTime1 = "05:05"
  LinkOnTime2 = "14:05"
  LinkOffTime2 = "23:55" 

  ' identification will be announce at this minute of each hour 
  sAnnouncementTime = "00"
  sStationName = "KGXXXX"
  bAnnouncementDone = false
 
  'Execute a batch file after each Connections. I use this function to send 
  'the file D:\Program Files\K1RFD\EchoLink\Calllog.txt on
  'my website after each Connections
  'Look at the end of this program for an example of FTP batch file
  bSendlog = True

  EndOfScript = False 
  ActiveConnections = false
  LinkEnable = True
  bFirstConnect = True
  
  ' ignore all errors
   on error resume next

  While not EndOfScript
    WScript.Sleep 2000
    MyTime = Time
 
    if AutoLinkDisable then
      if left(MyTime,5) >= LinkOnTime1 and left(MyTime,5) < LinkOffTime1 then
        ' Link Enabled with Time1 schedule
        If not LinkEnable then
          EnableLink
          LinkEnable = True
        end if
      else 
        if left(MyTime,5) >= LinkOnTime2 and left(MyTime,5) < LinkOffTime2 then
         ' Link Enabled with Time2 schedule
           If not LinkEnable then
             EnableLink
             LinkEnable = True
           end if
        else
          ' Link Disabled because out of schedule
          ' Wait until no connections are active before
          ' disabling the link
          If LinkEnable and not ActiveConnections then
            DisableLink
            LinkEnable = False
          end if 
       end if 
      end if
    end if 
    
    ' Announce the station name every hour,
    ' only if no station are connected and link is enable
    If LinkEnable and not ActiveConnections Then
      If  Right(Left(MyTime,5),2) = sAnnouncementTime and not bAnnouncementDone Then
         bAnnouncementDone = true
         oEchoLink.SayString sStationName
         oEchoLink.SayPhrase 2
         WScript.Sleep 3000
      End If
      If  Right(Left(MyTime,5),2) <> sAnnouncementTime and bAnnouncementDone Then
         bAnnouncementDone = false
      End If
    End If 

  Wend
 
  oEcholink.Quit
  WScript.DisconnectObject(oEchoLink)
  Set oEchoLink = Nothing
  'WScript.Echo "EchoLink exiting2"
  WScript.Quit


'################################
'# Sub fonctions Section
'################################

Sub EchoLink_Closing

  EndOfScript = True
  WScript.DisconnectObject(oEchoLink)
  Set oEchoLink = Nothing
  WScript.Quit

End Sub

Sub EnableLink
  EcholinkEnabled = True
  oEchoLink.EnableLink True
  oEchoLink.SayPhrase 9
  oEchoLink.SayString sStationName
  oEchoLink.SayPhrase 2
  oEchoLink.SayPhrase 3
end sub


Sub DisableLink
   EcholinkEnabled = False
   oEchoLink.EnableLink False
   oEchoLink.SayPhrase 9
   oEchoLink.SayString sStationName
   oEchoLink.SayPhrase 2
   oEchoLink.SayPhrase 8
end sub

Sub Echolink_Connected(sCall, sName, sAddr)
   if sCall <> "" then
    ActiveConnections = True
   else
    ActiveConnections = False
   end if   
end sub

Sub Echolink_Disconnected(sCall)
   Dim objFso 
   Dim objShell 

   Set objFso = WScript.CreateObject("Scripting.FileSystemObject") 
   Set objShell = WScript.CreateObject("WScript.Shell") 

   if sCall <> "" then
     ActiveConnections = False
     ' Send Call logfile on my website after each Connection 
     if bSendlog then
       With objFso 
         objShell.run "D:\Echolink\call_ftp.bat" , 1, True 
       End With 
       Set objShell = Nothing 
       Set objFso = Nothing
     end if
   else
     ActiveConnections = True
   end if  
end sub


'   #########################################################
'    This an example of my FTP commands to send the CallLog on my website.
'    Create this file and replace what's between [ ] with yours and
'    change the value of the variable "bSendlog" = TRUE to activate it.
'     File name: D:\Echolink\call_ftp.bat
'   #########################################################
'    cd D:\Program Files\K1RFD\EchoLink
'    echo user [your_ftp_user]  [your password] >tmp_ftp.txt
'    echo cd logs >>tmp_ftp.txt
'    echo put CallLog.txt >>tmp_ftp.txt
'    echo bye >>tmp_ftp.txt
'    ftp -n -s:tmp_ftp.txt  [your FTP address]	
'    del tmp_ftp.txt